import { openBlock as m, createElementBlock as c, normalizeClass as f, createElementVNode as p, withModifiers as a, withKeys as u, toDisplayString as x, normalizeStyle as I, Fragment as v, renderList as y, h as T, createTextVNode as S, createCommentVNode as V, withDirectives as M, vModelText as A } from "vue";
const l = {
  // cursor on input
  openOptions(e) {
    e.$refs.input.focus(), e.showMenu = !0, e.mousedownState = !1;
  },
  blurInput(e) {
    e.mousedownState || (e.searchText = "", e.closeOptions()), e.$emit("blur");
  },
  closeOptions(e) {
    e.showMenu = !1;
  },
  /**
   * up arrow key
   * 上の移動するときには新しいscroll位置を毎回セットする
   * Always scroll move, when "up arrow key" entered
   */
  prevItem(e) {
    const t = e.pointer - 1, i = e.$el.offsetHeight * t;
    t >= 0 && (e.pointer = t), e.$refs.menu.scrollTop = i;
  },
  /**
   *
   * down arrow key
   * ページsizeを計算してずれたらmove
   * calculate page size. If different between itemPage and currentPage move scroll
   */
  nextItem(e) {
    const t = e.pointer + 1, i = e.$el.offsetHeight * t;
    t <= e.filteredOptions.length - 1 && (e.pointer = t);
    const d = e.$refs.menu.offsetHeight, r = Math.ceil((e.$refs.menu.scrollTop + e.$el.offsetHeight) / d), s = Math.ceil(i / d);
    r !== s && (e.$refs.menu.scrollTop = (s - 1) * e.$refs.menu.offsetHeight);
  },
  // down enter key
  enterItem(e) {
    const t = e.filteredOptions[e.pointer];
    t && e.selectItem(t);
  },
  // mouse enter event on item
  pointerSet(e, t) {
    e.pointer = t;
  },
  pointerAdjust(e) {
    e.pointer >= e.filteredOptions.length - 1 && (e.pointer = e.filteredOptions.length ? e.filteredOptions.length - 1 : 0);
  },
  mousedownItem(e) {
    e.mousedownState = !0;
  }
};
function C(e) {
  return new RegExp(e.replace(/[.*+?^${}()|[\]\\]/g, "\\$&"), "i");
}
const O = {
  props: {
    id: {
      default: null
    },
    name: {
      type: String,
      default: ""
    },
    isError: {
      type: Boolean,
      default: !1
    },
    customAttr: {
      type: Function,
      default: () => ""
    },
    isDisabled: {
      type: Boolean,
      default: !1
    },
    placeholder: {
      type: String,
      default: ""
    },
    filterPredicate: {
      type: Function,
      default: (e, t) => e.match(C(t))
    }
  }
}, w = (e, t) => {
  const i = e.__vccOpts || e;
  for (const [d, r] of t)
    i[d] = r;
  return i;
}, E = {
  name: "ModelSelect",
  mixins: [O],
  emits: ["blur", "searchchange", "update:modelValue"],
  props: {
    modelValue: {
      type: [String, Number, Object, Boolean]
    },
    customAttr: {
      type: Function,
      default: () => ""
    },
    options: {
      type: Array
    }
  },
  data() {
    return {
      showMenu: !1,
      searchText: "",
      mousedownState: !1,
      // mousedown on option menu
      pointer: -1
    };
  },
  watch: {
    value(e) {
      this.pointer = this.filteredOptions.findIndex((t) => t.value === this.optionValue(e));
    },
    filteredOptions() {
      this.pointerAdjust();
    },
    searchText() {
      this.$emit("searchchange", this.searchText);
    }
  },
  computed: {
    searchTextCustomAttr() {
      return this.selectedOption && this.selectedOption.value ? this.customAttr(this.selectedOption) : "";
    },
    inputText() {
      if (this.searchText)
        return "";
      {
        let e = this.placeholder;
        return this.selectedOption && (e = this.selectedOption.text), e;
      }
    },
    customAttrs() {
      try {
        if (Array.isArray(this.options))
          return this.options.map((e) => this.customAttr(e));
      } catch {
      }
      return [];
    },
    textClass() {
      return !this.selectedOption && this.placeholder ? "default" : "";
    },
    menuClass() {
      return {
        visible: this.showMenu,
        hidden: !this.showMenu
      };
    },
    menuStyle() {
      return {
        display: this.showMenu ? "block" : "none"
      };
    },
    filteredOptions() {
      return this.searchText ? this.options.filter((e) => {
        try {
          return this.filterPredicate(e.text, this.searchText);
        } catch {
          return !0;
        }
      }) : this.options;
    },
    selectedOption() {
      return this.options.find((e) => e.value === this.optionValue(this.modelValue));
    }
  },
  methods: {
    deleteTextOrItem() {
      !this.searchText && this.modelValue && (this.selectItem({}), this.openOptions());
    },
    openOptions() {
      l.openOptions(this);
    },
    blurInput() {
      l.blurInput(this);
    },
    closeOptions() {
      l.closeOptions(this);
    },
    prevItem() {
      l.prevItem(this);
    },
    nextItem() {
      l.nextItem(this);
    },
    enterItem() {
      l.enterItem(this);
    },
    pointerSet(e) {
      l.pointerSet(this, e);
    },
    pointerAdjust() {
      l.pointerAdjust(this);
    },
    mousedownItem() {
      l.mousedownItem(this);
    },
    selectItem(e) {
      this.searchText = "", this.closeOptions(), typeof this.modelValue == "object" && this.modelValue ? this.$emit("update:modelValue", e) : (this.$emit("update:modelValue", e.value), e.value === e.text && (this.searchText = e.value));
    },
    optionValue(e) {
      return typeof e == "object" && e !== null ? e.value : e;
    }
  }
}, k = /* @__PURE__ */ p("i", { class: "dropdown icon" }, null, -1), j = ["disabled", "tabindex", "id", "name", "value"], D = ["data-vss-custom-attr"], R = ["data-vss-custom-attr", "onClick", "onMouseenter"];
function F(e, t, i, d, r, s) {
  return m(), c("div", {
    class: f(["ui fluid search selection dropdown", { "active visible": r.showMenu, error: e.isError, disabled: e.isDisabled }]),
    onClick: t[11] || (t[11] = (...n) => s.openOptions && s.openOptions(...n)),
    onFocus: t[12] || (t[12] = (...n) => s.openOptions && s.openOptions(...n))
  }, [
    k,
    p("input", {
      class: "search",
      autocomplete: "off",
      disabled: e.isDisabled,
      tabindex: e.isDisabled ? -1 : 0,
      id: e.id,
      name: e.name,
      value: r.searchText,
      onInput: t[0] || (t[0] = (n) => r.searchText = n.target.value),
      ref: "input",
      onFocus: t[1] || (t[1] = a((...n) => s.openOptions && s.openOptions(...n), ["prevent"])),
      onKeyup: [
        t[2] || (t[2] = u((...n) => s.closeOptions && s.closeOptions(...n), ["esc"])),
        t[7] || (t[7] = u(a((...n) => s.enterItem && s.enterItem(...n), ["prevent"]), ["enter"]))
      ],
      onBlur: t[3] || (t[3] = (...n) => s.blurInput && s.blurInput(...n)),
      onKeydown: [
        t[4] || (t[4] = u((...n) => s.prevItem && s.prevItem(...n), ["up"])),
        t[5] || (t[5] = u((...n) => s.nextItem && s.nextItem(...n), ["down"])),
        t[6] || (t[6] = u(a(() => {
        }, ["prevent"]), ["enter"])),
        t[8] || (t[8] = u((...n) => s.deleteTextOrItem && s.deleteTextOrItem(...n), ["delete"]))
      ]
    }, null, 40, j),
    p("div", {
      class: f(["text", s.textClass]),
      "data-vss-custom-attr": s.searchTextCustomAttr
    }, x(s.inputText), 11, D),
    p("div", {
      class: f(["menu", s.menuClass]),
      ref: "menu",
      onMousedown: t[10] || (t[10] = a(() => {
      }, ["prevent"])),
      style: I(s.menuStyle),
      tabindex: "-1"
    }, [
      (m(!0), c(v, null, y(s.filteredOptions, (n, o) => (m(), c("div", {
        key: o,
        class: f(["item", { selected: n.selected || r.pointer === o }]),
        "data-vss-custom-attr": s.customAttrs[o] ? s.customAttrs[o] : "",
        onClick: a((h) => s.selectItem(n), ["stop"]),
        onMousedown: t[9] || (t[9] = (...h) => s.mousedownItem && s.mousedownItem(...h)),
        onMouseenter: (h) => s.pointerSet(o)
      }, x(n.text), 43, R))), 128))
    ], 38)
  ], 34);
}
const g = /* @__PURE__ */ w(E, [["render", F]]), W = {
  name: "ModelListSelect",
  mixins: [O],
  emits: ["blur", "searchchange", "update:modelValue"],
  render: function() {
    return T(g, {
      id: this.id,
      name: this.name,
      options: this.options,
      modelValue: this.innerValue,
      isError: this.isError,
      isDisabled: this.isDisabled,
      placeholder: this.placeholder,
      filterPredicate: this.filterPredicate,
      "onUpdate:modelValue": this.onInput,
      onSearchchange: (e) => this.$emit("searchchange", e)
    });
  },
  props: {
    modelValue: {
      type: [String, Number, Object, Boolean]
    },
    list: {
      type: Array
    },
    optionValue: {
      type: String
    },
    optionText: {
      type: String
    },
    customText: {
      type: Function
    }
  },
  computed: {
    options() {
      return this.list.map((e) => ({ value: e[this.optionValue], text: this.buildText(e) }));
    },
    innerValue() {
      return this.modelValue ? typeof this.modelValue == "object" ? this.modelValue ? { value: this.modelValue[this.optionValue], text: this.buildText(this.modelValue) } : { value: "", text: "" } : this.modelValue : this.modelValue;
    }
  },
  methods: {
    buildText(e) {
      return e[this.optionValue] !== void 0 ? this.customText ? this.customText(e) : e[this.optionText] : "";
    },
    onInput(e) {
      if (e === void 0)
        return this.$emit("update:modelValue", "");
      if (Object.keys(e).length === 0 && e.constructor === Object)
        this.$emit("update:modelValue", e);
      else if (typeof e == "object") {
        const t = this.list.find((i) => i[this.optionValue] === e.value);
        this.$emit("update:modelValue", t);
      } else
        this.$emit("update:modelValue", e);
    }
  },
  components: {
    ModelSelect: g
  }
}, B = {
  name: "MultiSelect",
  mixins: [O],
  emits: ["blur", "searchchange", "select"],
  props: {
    customAttr: {
      type: Function,
      default: () => ""
    },
    options: {
      type: Array
    },
    selectedOptions: {
      type: Array
    },
    cleanSearch: {
      type: Boolean,
      default: !0
    },
    hideSelectedOptions: {
      type: Boolean,
      default: !1
    }
  },
  data() {
    return {
      showMenu: !1,
      searchText: "",
      mousedownState: !1,
      // mousedown on option menu
      pointer: -1
    };
  },
  watch: {
    selectedOptions() {
      this.pointer = -1;
    },
    filteredOptions() {
      this.pointerAdjust();
    },
    searchText() {
      this.$emit("searchchange", this.searchText);
    }
  },
  computed: {
    inputText() {
      return this.searchText ? "" : this.placeholder;
    },
    textClass() {
      return this.placeholder ? "default" : "";
    },
    inputWidth() {
      return {
        width: (this.searchText.length + 1) * 8 + 20 + "px"
      };
    },
    menuClass() {
      return {
        visible: this.showMenu,
        hidden: !this.showMenu
      };
    },
    menuStyle() {
      return {
        display: this.showMenu ? "block" : "none"
      };
    },
    nonSelectOptions() {
      return this.options.filter((e) => this.selectedOptions.findIndex((t) => t.value === e.value) === -1);
    },
    filteredOptions() {
      return this.searchText ? this.nonSelectOptions.filter((e) => {
        try {
          return this.cleanSearch ? this.filterPredicate(this.accentsTidy(e.text), this.searchText) : this.filterPredicate(e.text, this.searchText);
        } catch {
          return !0;
        }
      }) : this.nonSelectOptions;
    }
  },
  methods: {
    deleteTextOrLastItem() {
      !this.searchText && this.selectedOptions.length > 0 && this.deleteItem(this.selectedOptions[this.selectedOptions.length - 1]);
    },
    openOptions() {
      l.openOptions(this);
    },
    blurInput() {
      l.blurInput(this);
    },
    closeOptions() {
      l.closeOptions(this);
    },
    prevItem() {
      l.prevItem(this), this.closeOptions(), this.openOptions();
    },
    nextItem() {
      l.nextItem(this), this.closeOptions(), this.openOptions();
    },
    enterItem() {
      l.enterItem(this);
    },
    pointerSet(e) {
      l.pointerSet(this, e);
    },
    pointerAdjust() {
      l.pointerAdjust(this);
    },
    mousedownItem() {
      l.mousedownItem(this);
    },
    selectItem(e) {
      const t = this.selectedOptions.concat(e), i = t.filter((d, r) => t.indexOf(d) === r);
      this.closeOptions(), this.searchText = "", this.$emit("select", i, e, "insert");
    },
    deleteItem(e) {
      const t = this.selectedOptions.filter((i) => i.value !== e.value);
      this.$emit("select", t, e, "delete");
    },
    accentsTidy(e) {
      let t = e.toString().toLowerCase();
      return t = t.replace(new RegExp("[àáâãäå]", "g"), "a"), t = t.replace(new RegExp("æ", "g"), "ae"), t = t.replace(new RegExp("ç", "g"), "c"), t = t.replace(new RegExp("[èéêë]", "g"), "e"), t = t.replace(new RegExp("[ìíîï]", "g"), "i"), t = t.replace(new RegExp("ñ", "g"), "n"), t = t.replace(new RegExp("[òóôõö]", "g"), "o"), t = t.replace(new RegExp("œ", "g"), "oe"), t = t.replace(new RegExp("[ùúûü]", "g"), "u"), t = t.replace(new RegExp("[ýÿ]", "g"), "y"), t;
    }
  }
}, P = /* @__PURE__ */ p("i", { class: "dropdown icon" }, null, -1), L = ["data-vss-custom-attr"], H = ["onClick"], K = ["tabindex", "id", "name"], N = ["data-vss-custom-attr", "onClick", "onMouseenter"];
function z(e, t, i, d, r, s) {
  return m(), c("div", {
    class: f(["ui fluid search dropdown selection multiple", { "active visible": r.showMenu, error: e.isError, disabled: e.isDisabled }]),
    onClick: t[11] || (t[11] = (...n) => s.openOptions && s.openOptions(...n)),
    onFocus: t[12] || (t[12] = (...n) => s.openOptions && s.openOptions(...n))
  }, [
    P,
    i.hideSelectedOptions ? V("", !0) : (m(!0), c(v, { key: 0 }, y(i.selectedOptions, (n, o) => (m(), c("a", {
      key: o,
      class: "ui label transition visible",
      style: { display: "inline-block !important" },
      "data-vss-custom-attr": i.customAttr(n)
    }, [
      S(x(n.text), 1),
      p("i", {
        class: "delete icon",
        onClick: (h) => s.deleteItem(n)
      }, null, 8, H)
    ], 8, L))), 128)),
    M(p("input", {
      class: "search",
      autocomplete: "off",
      tabindex: e.isDisabled ? -1 : 0,
      id: e.id,
      name: e.name,
      "onUpdate:modelValue": t[0] || (t[0] = (n) => r.searchText = n),
      ref: "input",
      style: I(s.inputWidth),
      onFocus: t[1] || (t[1] = a((...n) => s.openOptions && s.openOptions(...n), ["prevent"])),
      onKeyup: [
        t[2] || (t[2] = u((...n) => s.closeOptions && s.closeOptions(...n), ["esc"])),
        t[7] || (t[7] = u(a((...n) => s.enterItem && s.enterItem(...n), ["prevent"]), ["enter"]))
      ],
      onBlur: t[3] || (t[3] = (...n) => s.blurInput && s.blurInput(...n)),
      onKeydown: [
        t[4] || (t[4] = u((...n) => s.prevItem && s.prevItem(...n), ["up"])),
        t[5] || (t[5] = u((...n) => s.nextItem && s.nextItem(...n), ["down"])),
        t[6] || (t[6] = u(a(() => {
        }, ["prevent"]), ["enter"])),
        t[8] || (t[8] = u((...n) => s.deleteTextOrLastItem && s.deleteTextOrLastItem(...n), ["delete"]))
      ]
    }, null, 44, K), [
      [A, r.searchText]
    ]),
    p("div", {
      class: f(["text", s.textClass])
    }, x(s.inputText), 3),
    p("div", {
      class: f(["menu", s.menuClass]),
      ref: "menu",
      onMousedown: t[10] || (t[10] = a(() => {
      }, ["prevent"])),
      style: I(s.menuStyle),
      tabindex: "-1"
    }, [
      (m(!0), c(v, null, y(s.filteredOptions, (n, o) => (m(), c("div", {
        key: o,
        class: f(["item", { selected: n.selected || r.pointer === o }]),
        "data-vss-custom-attr": i.customAttr(n),
        onClick: a((h) => s.selectItem(n), ["stop"]),
        onMousedown: t[9] || (t[9] = (...h) => s.mousedownItem && s.mousedownItem(...h)),
        onMouseenter: (h) => s.pointerSet(o)
      }, x(n.text), 43, N))), 128))
    ], 38)
  ], 34);
}
const b = /* @__PURE__ */ w(B, [["render", z]]), q = {
  name: "MultiListSelect",
  mixins: [O],
  emits: ["blur", "searchchange", "select"],
  render: function() {
    return T(b, {
      id: this.id,
      name: this.name,
      options: this.options,
      selectedOptions: this.items,
      isError: this.isError,
      isDisabled: this.isDisabled,
      placeholder: this.placeholder,
      filterPredicate: this.filterPredicate,
      onSelect: this.onSelect,
      onSearchchange: (e) => this.$emit("searchchange", e)
    });
  },
  props: {
    list: {
      type: Array
    },
    optionValue: {
      type: String
    },
    optionText: {
      type: String
    },
    customText: {
      type: Function
    },
    selectedItems: {
      type: Array
    }
  },
  computed: {
    options() {
      return this.list.map((e) => ({ value: e[this.optionValue], text: this.buildText(e) }));
    },
    items() {
      return this.selectedItems.map((e) => ({ value: e[this.optionValue], text: this.buildText(e) }));
    }
  },
  methods: {
    buildText(e) {
      return e[this.optionValue] !== void 0 ? this.customText ? this.customText(e) : e[this.optionText] : "";
    },
    onSelect(e, t) {
      if (Object.keys(t).length === 0 && t.constructor === Object)
        this.$emit("select", e, t);
      else {
        const i = this.list.filter((r, s) => e.find((n, o) => r[this.optionValue] === n.value)), d = this.list.find((r) => r[this.optionValue] === t.value);
        this.$emit("select", i, d);
      }
    }
  },
  components: {
    MultiSelect: b
  }
};
export {
  W as ModelListSelect,
  g as ModelSelect,
  q as MultiListSelect,
  b as MultiSelect
};
